/** MIT License - Copyright (c) 2021 Samarium */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  generate: () => generate,
  renderOnCanvas: () => renderOnCanvas
});
var import_utils = __toModule(require("./utils"));
var import_Module = __toModule(require("./utils/Module"));
const defaultGeneratorOptions = {
  version: 1,
  ecl: "LOW",
  forced: false,
  mask: -1
};
const defaultRenderOptions = {
  c1: "#000000",
  c2: "#FFFFFF",
  size: 10
};
function generate(text, options = defaultGeneratorOptions) {
  const version = options.version, ecl = options.ecl, forced = options.forced, mask = options.mask, codePoints = (0, import_utils.generateCodePoint)(text), [optimalVersion, segments] = (0, import_utils.generateOptimalSegments)(codePoints, version, ecl, forced), codeword = (0, import_utils.generateCodeword)((0, import_utils.generateDataCodeword)(segments, optimalVersion, ecl), optimalVersion, ecl), code = (0, import_utils.generateRawQR)(codeword, optimalVersion, ecl), optimalMask = mask == -1 ? (0, import_utils.computeOptimalMask)(code) : [mask, code.generateMask(mask)];
  (0, import_utils.generateQR)(code, optimalMask);
  code.extend();
  return code;
}
function renderOnCanvas(code, id, options = defaultRenderOptions) {
  const output = document.createElement("canvas"), context = output.getContext("2d"), numBlock = code.getSize() + 8, size = options.size;
  if (!context)
    throw Error("Cannot get canvas context");
  output.id = id;
  output.width = numBlock * size;
  output.height = numBlock * size;
  const modules = code.getModules();
  for (let row = 0; row < numBlock; row++) {
    for (let col = 0; col < numBlock; col++) {
      const module2 = modules[row][col];
      context.fillStyle = module2 instanceof import_Module.QuietModule ? "#FFFFFF" : module2.getColor() ? options.c1 : options.c2;
      context.fillRect(col * size, row * size, size, size);
    }
  }
  context.stroke();
  return output;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generate,
  renderOnCanvas
});
//# sourceMappingURL=index.js.map
