/** MIT License - Copyright (c) 2021 Samarium */
var __defProp = Object.defineProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
__export(exports, {
  default: () => CodePoint
});
class CodePoint {
  utf16_char;
  utf8_code;
  constructor(char) {
    this.utf16_char = char;
    this.utf8_code = CodePoint.toUTF8Array(char);
  }
  static toUTF8Array(str) {
    const result = [];
    for (let i = 0; i < str.length; i++) {
      let char_code = str.charCodeAt(i);
      if (char_code < 128)
        result.push(char_code);
      else if (char_code < 2048) {
        result.push(192 | char_code >> 6, 128 | char_code & 63);
      } else if (char_code < 55296 || char_code >= 57344) {
        result.push(224 | char_code >> 12, 128 | char_code >> 6 & 63, 128 | char_code & 63);
      } else {
        char_code = (char_code & 1023) << 10 | (str.charCodeAt(++i) & 1023) + 65536;
        result.push(240 | char_code >> 18, 128 | char_code >> 12 & 63, 128 | char_code >> 6 & 63, 128 | char_code & 63);
      }
    }
    return result;
  }
  getChar() {
    return this.utf16_char;
  }
  getCode() {
    return this.utf8_code;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=CodePoint.js.map
