/** MIT License - Copyright (c) 2021 Samarium */
var __defProp = Object.defineProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
__export(exports, {
  Codeword: () => Codeword,
  DataCodeword: () => DataCodeword,
  ECCodeword: () => ECCodeword
});
class Codeword {
  pre_interleave_index = -1;
  block_index = -1;
  index = -1;
  post_interleave_index = -1;
  value;
  constructor(value) {
    if (value < 0 || value > 255)
      throw Error(`Invalid Value ${value}`);
    this.value = value;
  }
  setBlockIndex(value) {
    this.block_index = value;
  }
  setIndex(value) {
    this.index = value;
  }
  setPreInterleaveIndex(value) {
    this.pre_interleave_index = value;
  }
  setPostInterleaveIndex(value) {
    this.post_interleave_index = value;
  }
  getValue() {
    return this.value;
  }
}
class DataCodeword extends Codeword {
  constructor(value) {
    super(value);
  }
}
class ECCodeword extends Codeword {
  constructor(value) {
    super(value);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Codeword,
  DataCodeword,
  ECCodeword
});
//# sourceMappingURL=Codeword.js.map
