/** MIT License - Copyright (c) 2021 Samarium */
import { Literal, Number, Tuple, Union } from "runtypes";
const Mode = Union(Literal("BYTE"), Literal("NUMERIC"), Literal("ALPHANUMERIC"), Literal("KANJI"));
const Ecl = Union(Literal("LOW"), Literal("MEDIUM"), Literal("QUARTILE"), Literal("HIGH"));
const Functional = Union(Literal("FINDER"), Literal("SEPARATOR"), Literal("TIMING"), Literal("ALIGNMENT"), Literal("FORMAT_INFO"), Literal("VERSION_INFO"), Literal("Dark"));
const Position = Tuple(Number, Number);
const Version = Number.withConstraint((n) => 1 <= n && n <= 40 || `${n} is not a valid version number`);
const Mask = Number.withConstraint((n) => -1 <= n && n <= 7 || `${n} is not a valid mask choice`);
export {
  Ecl,
  Mask,
  Version
};
//# sourceMappingURL=types.js.map
